#include "DataContainer.h"

#include <iostream>
#include <list>
#include <set>

BeginDataContainersDefinition(aritmetic);
  DefineDataContainerFor (int, Int);
  DefineDataContainerFor (double, Double);
EndDataContainersDefinition;

BeginDataContainersDefinition(containers);
  DefineDataContainerFor (std::list<int>, List);
  DefineDataContainerFor (std::set<char>, Set);
EndDataContainersDefinition;

int main(void)
{
    NewDataContainer(aritmetic, myAriDC);
    NewDataContainer(containers, myConDC);

    myAriDC->SetDouble("PI", 3.14);
    myAriDC->SetDouble("PI4", 3.1415);
    myAriDC->SetInt("shoes number", 44);

    std::list<int> underList;
    underList.push_back(2);
    underList.push_back(3);
    underList.push_back(4);
	
    std::list<int> overList;
    overList.push_back(12);
    overList.push_back(13);
    overList.push_back(14);

    std::set<char> vowels;
    vowels.insert('a');
    vowels.insert('e');
    vowels.insert('i');
    vowels.insert('i'); /* value doubled */
    vowels.insert('o');
    vowels.insert('u');

    std::set<char> consonant;
    consonant.insert('b');
    consonant.insert('x');
    consonant.insert('w');

    myConDC->SetList("belowTen", underList);
    myConDC->SetList("aboveTen", overList);
    myConDC->SetSet("vowels", vowels);
    myConDC->SetSet("consonant", consonant);

    if (myAriDC->IsSetInt("shoes number")) {
	std::cout << "Shoes number: " << myAriDC->GetInt("shoes number") << std::endl;
    }

    if (!myAriDC->IsSetDouble("GI")) {
	std::cout << "GI is not set" << std::endl;
    }

    std::cout << "Iterate forwards" << std::endl;

    for (myAriDC->DoubleIteratorInit(); myAriDC->DoubleIteratorHasNext(); myAriDC->DoubleIteratorNext()) {
	std::cout << myAriDC->DoubleIteratorGetKey() << " : " << myAriDC->DoubleIteratorGetValue() << std::endl;
    }

    std::cout << "List lists" << std::endl;
    for (myConDC->ListIteratorInit(); myConDC->ListIteratorHasNext(); myConDC->ListIteratorNext()) {
	std::cout << myConDC->ListIteratorGetKey() << " : " << std::endl;
	std::list<int> list = myConDC->ListIteratorGetValue();
	for(std::list<int>::iterator it = list.begin(); it != list.end(); it++) {
	    std::cout << "   " << (*it) << std::endl;
	}
    }

    std::cout << "List sets" << std::endl;
    for (myConDC->SetIteratorInit(); myConDC->SetIteratorHasNext(); myConDC->SetIteratorNext()) {
	std::cout << myConDC->SetIteratorGetKey() << " : " << std::endl;
	std::set<char> set = myConDC->SetIteratorGetValue();
	for(std::set<char>::iterator it = set.begin(); it != set.end(); it++) {
	    std::cout << "   " << (*it) << std::endl;
	}
    }

    FreeDataContainer(myAriDC);
    FreeDataContainer(myConDC);
}
